## percona-xtrabackup 2.1.3-618

=== debian/changelog ===
percona-xtrabackup (2.1.3-618-1) unstable; urgency=low

  [ Stewart Smith ]
  * Initial packaging for Debian (Closes: #620824)

  [ Clint Byrum ]
  * Remove inaccurate Vcs-* fields.
  * Remove MAKE_J setting as it is handled by dpkg build tools.
  * Remove unnecesssary debian/percona-xtrabackup.dirs
  * Updating standards to 3.9.4, no changes necessary.
  * Add embedded-library libmysqlclient to
    percona-xtrabackup.lintian-overrides.

 -- Stewart Smith <stewart.smith@percona.com>  Fri, 19 Jul 2013 16:18:36 +1000

percona-xtrabackup (2.1.0) unstable; urgency=low

  * Update compat level to 7
  * Update Standards-Version to 3.9.1.
  * Use dh targets and overrides.
  * Remove the obsolete debian/info file
  * Move the /usr/share/percona-xtrabackup-test directory to
    the percona-xtrabackup-test package.
  * Update the copyright file to a machine-readable format.

 -- Ignacio Nin <ignacio.nin@percona.com>  Mon, 22 Apr 2013 16:14:20 -0300

percona-xtrabackup (2.0.0) lucid; urgency=low

  * General polishing of debian/ directory
  * Add correct copyright info
  * Move rules for installing files (binaries and test) from rules to
    .install and .links files
  * Create per-package .dirs and .docs files
  * Add a lintian-overrides files

 -- Ignacio Nin <ignacio.nin@percona.com>  Wed, 18 Apr 2012 02:34:40 +0000
