=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: database
 Priority: extra
 Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
-Uploaders: Stewart Smith <stewart.smith@percona.com>, Ignacio Nin <ignacio.nin@percona.com>, Clint Byrum <spamaps@debian.org>
+Uploaders: Stewart Smith <stewart.smith@percona.com>, Ignacio Nin <ignacio.nin@percona.com>, Clint Byrum <clint@fewbar.com>
 Build-Depends: automake,
                bison,
                ca-certificates,
@@ -14,8 +14,10 @@
                libtool,
                libz-dev,
                libgcrypt-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.3
 Homepage: http://www.percona.com/software/percona-xtrabackup
+Vcs-Browser: http://bazaar.launchpad.net/~percona-core/percona-xtrabackup/2.1/files
+Vcs-Bzr: lp:percona-xtrabackup/2.1
 
 Package: percona-xtrabackup
 Architecture: any
@@ -44,12 +46,3 @@
  Test suite for Percona XtraBackup. Install this package if you intend
  to run XtraBackup's test suite.
 
-Package: xtrabackup
-Architecture: all
-Section: oldlibs
-Depends: percona-xtrabackup, ${misc:Depends}
-Description: Transitional package for percona-xtrabackup
- In 2.0.0, the XtraBackup package name was rebranded to
- percona-xtrabackup. This package is an empty dummy package
- that depends on percona-xtrabackup, and replaces older versions of
- xtrabackup (2.0.0). It is not intended to be installed manually.
